<?php

/*
=====================================================
 This ExpressionEngine extension was created by Laisvunas
 - http://expressionengine.com/forums/member/38398/
=====================================================
 This program is freeware; 
 you may use this code for any purpose, commercial or
 private, without any further permission from the author.   
=====================================================
 Files: lang.url_title_symbols.php, ext.url_title_symbols.php
=====================================================
 Purpose: customized handling of special symbols in url_titles.
=====================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}

class Url_title_symbols {

  var $DEV_MODE = 0; // 1
  var $settings = array();
 	var $name = 'URL title symbols';
 	var $classname = 'Url_title_symbols';
 	var $version = '1.0';
 	var $description = 'Customized handling of special symbols in url_titles';
 	var $settings_exist = 'y';
 	var $docs_url = 'http://expressionengine.com/forums/viewthread/141356/'; 

  //------------------------------------
 	//   Constructor - Settings
 	//------------------------------------
 	
 	function Url_title_symbols($settings = '')
 	{
    
    $this->settings = $settings;

 	}
 	// END FUNCTION 

  function activate_extension()
 	{
  		global $DB;
  		
  		$DB->query($DB->insert_string('exp_extensions',
   				array(
    				'extension_id'	=> '',
    				'class'	=> $this->classname,
    				'method' => 'submit_new_entry_start',
    				'hook'	=> 'submit_new_entry_start',
    				'settings'	=> '',
    				'priority'	=> 5,
    				'version'	=> $this->version,
    				'enabled'	=> 'y'
    				)
   			)
  		);
    
    $DB->query($DB->insert_string('exp_extensions',
   				array(
    				'extension_id'	=> '',
    				'class'	=> $this->classname,
    				'method' => 'show_full_control_panel_end',
    				'hook'	=> 'show_full_control_panel_end',
    				'settings'	=> '',
    				'priority'	=> 5,
    				'version'	=> $this->version,
    				'enabled'	=> 'y'
    				)
   			)
  		);
 	}
 	// END FUNCTION 

  //------------------------------------
 	//  Update Extension
 	//------------------------------------
 	
 	function update_extension($current='')
 	{
  		global $DB;
  		
  		if ($current == '' OR $current == $this->version)
  		{
  			return FALSE;
  		}
  		
  		if ($current < $this->version)
  		{
  			 $DB->query("UPDATE exp_extensions 
  					SET version = '".$DB->escape_str($this->version)."' 
  					WHERE class = '".$this->classname."'");
  		}
 	}
 	// END FUNCTION 

  //------------------------------------
 	//  Disable Extension 
 	//------------------------------------
 	
 	function disable_extension()
 	{
  		global $DB;
    
  		$DB->query("UPDATE exp_extensions SET enabled='n' WHERE class='".$this->classname."'");
    
  		if ($this->DEV_MODE)
    {
      $DB->query("DELETE FROM exp_extensions WHERE class = '".$this->classname."'");
    } 
 	}
 	// END FUNCTION 
  
  //------------------------------------
 	//  Extension Settings
 	//------------------------------------
  
  function settings()
 	{
  		global $DB, $LANG;
  		
  		$settings = array();
  					
  		$settings['allow_dashes_question']	= array('s', array(
														'y' => $LANG->line('yes'), 
														'n' => $LANG->line('no')), 'y');
    $settings['allow_underscores_question']	= array('s', array(
														'y' => $LANG->line('yes'), 
														'n' => $LANG->line('no')), 'y');
    $settings['allow_periods_question']	= array('s', array(
														'y' => $LANG->line('yes'), 
														'n' => $LANG->line('no')), 'y');
    $settings['allow_uppercase_question']	= array('s', array(
														'y' => $LANG->line('yes'), 
														'n' => $LANG->line('no')), 'y');
  		
  		return $settings;
 	}
 	// END FUNCTION
  
  function submit_new_entry_start()
  {
    global $DB, $PREFS;
    
    $url_title = trim($_POST['url_title']);
    $settings = $this->settings;
    
    if ($url_title)
    {
      if (isset($settings['allow_dashes_question']) AND $settings['allow_dashes_question'] == 'n')
      {
        $dashes_allowed = 'n';
      }
      else
      {
        $dashes_allowed = 'y';
      }
      
      if (isset($settings['allow_underscores_question']) AND $settings['allow_underscores_question'] == 'n')
      {
        $underscores_allowed = 'n';
      }
      else
      {
        $underscores_allowed = 'y';
      }
      
      if (isset($settings['allow_periods_question']) AND $settings['allow_periods_question'] == 'n')
      {
        $periods_allowed = 'n';
      }
      else
      {
        $periods_allowed = 'y';
      }
      
      if (isset($settings['allow_uppercase_question']) AND $settings['allow_uppercase_question'] == 'n')
      {
        $uppercase_allowed = 'n';
      }
      else
      {
        $uppercase_allowed = 'y';
      }
      
      $sql_separator = "SELECT site_weblog_preferences
                        FROM exp_sites
                        WHERE site_id = '".$PREFS->ini('site_id')."'
                        LIMIT 1";
      $query_separator = $DB->query($sql_separator);
      if ($query_separator->num_rows == 1)
      {
        $site_weblog_preferences = unserialize($query_separator->row['site_weblog_preferences']);
        $separator = $site_weblog_preferences['word_separator'];
      }
      else
      {
        $separator = 'dash';
      }
      //echo '$separator: '.$separator; echo '<hr>';
      
      if ($dashes_allowed == 'n' AND $separator == 'underscore')
      {
        $url_title = preg_replace('/\-+/', '_', $url_title);
      }
      
      if ($underscores_allowed == 'n' AND $separator == 'dash')
      {
        $url_title = preg_replace('/\_+/', '-', $url_title);
      }
      
      if ($periods_allowed == 'n' AND $separator == 'dash')
      {
        $url_title = preg_replace('/\.+/', '-', $url_title);
      }
      elseif ($periods_allowed == 'n' AND $separator == 'underscore')
      {
        $url_title = preg_replace('/\.+/', '_', $url_title);
      }
      
      if ($uppercase_allowed == 'n')
      {
        $url_title = strtolower($url_title);
      }
      
      $_POST['url_title'] = $url_title;
    } 
  }
  // END FUNCTION
  
  function show_full_control_panel_end($out)
  {
    global $EXT, $IN, $PREFS, $DB;
    
    $out = ($EXT->last_call !== FALSE) ? $EXT->last_call : $out;
    
    $settings = $this->settings;
    
    if (isset($settings['allow_dashes_question']) AND $settings['allow_dashes_question'] == 'n')
    {
      $dashes_allowed = 'n';
    }
    else
    {
      $dashes_allowed = 'y';
    }
    
    if (isset($settings['allow_underscores_question']) AND $settings['allow_underscores_question'] == 'n')
    {
      $underscores_allowed = 'n';
    }
    else
    {
      $underscores_allowed = 'y';
    }
    
    if (isset($settings['allow_periods_question']) AND $settings['allow_periods_question'] == 'n')
    {
      $periods_allowed = 'n';
    }
    else
    {
      $periods_allowed = 'y';
    }
    
    if (isset($settings['allow_uppercase_question']) AND $settings['allow_uppercase_question'] == 'n')
    {
      $uppercase_allowed = 'n';
    }
    else
    {
      $uppercase_allowed = 'y';
    }
    
    $sql_separator = "SELECT site_weblog_preferences
                      FROM exp_sites
                      WHERE site_id = '".$PREFS->ini('site_id')."'
                      LIMIT 1";
    $query_separator = $DB->query($sql_separator);
    if ($query_separator->num_rows == 1)
    {
      $site_weblog_preferences = unserialize($query_separator->row['site_weblog_preferences']);
      $separator = $site_weblog_preferences['word_separator'];
    }
    else
    {
      $separator = 'dash';
    }
    //echo '$separator: '.$separator; echo '<hr>';
    
    ob_start(); 
    ?>
    <script type="text/javascript">
    urlTitleSymbols = {
      
      addEvent: function(elm, evType, fn, useCapture) { //cross-browser event handling by Scott Andrew
       	if(elm.addEventListener){
        		elm.addEventListener(evType, fn, useCapture);
        		return true;
        }
        else if(elm.attachEvent){
        		var r = elm.attachEvent("on" + evType, fn);
        		return r;
        }
        else {
        		elm["on" + evType] = fn;
        }
      },
      
      parseURLTitle: function() {
        var dashes_allowed;
        var underscores_allowed;
        var periods_allowed;
        var uppercase_allowed;
        var url_title_textinput;
        var url_title;
        var separator;
        
        dashes_allowed = '{$dashes_allowed}';
        underscores_allowed = '{$underscores_allowed}';
        periods_allowed = '{$periods_allowed}';
        uppercase_allowed = '{$uppercase_allowed}';
        separator = '{$separator}';
        
        url_title_textinput = document.getElementById('url_title');
        
        if (url_title_textinput && url_title_textinput.value) {
          //alert('url_title_textinput.value: ' + url_title_textinput.value);
          url_title = url_title_textinput.value;
          
          if (dashes_allowed == 'n' && separator == 'underscore') {
            url_title = url_title.replace(/\-+/g, '_');
          }
          
          if (underscores_allowed == 'n' && separator == 'dash') {
            url_title = url_title.replace(/\_+/g, '-');
          }
          
          if (periods_allowed == 'n' && separator == 'dash') {
            url_title = url_title.replace(/\.+/g, '-');
          }
          else if (periods_allowed == 'n' && separator == 'underscore') {
            url_title = url_title.replace(/\.+/g, '_');
            //alert('url_title: ' + url_title);
          }
          
          if (uppercase_allowed == 'n') {
            url_title = url_title.toLowerCase();
          }
          
          url_title_textinput.value = url_title;
        }
      },
      
      encodeUppercase: function() {
        var uppercase_allowed;
        var title_textinput;
        var title;
        var title_new;
        
        title_new = '';
        title_textinput = document.getElementById('title');
        uppercase_allowed = '{$uppercase_allowed}';
        if (uppercase_allowed == 'y' && title_textinput) {
          title = title_textinput.value;
          for (var i = 0; i < title.length; i++) {
            if (title.charCodeAt(i) > 64 && title.charCodeAt(i) < 91) {
              title_new = '' + title_new + 'x' + title.charCodeAt(i) + 'x';
            }
            else {
              title_new = '' + title_new + title[i];
            }
          }
          title_textinput.value = title_new;
        }
      },
      
      decodeUppercase: function() {
        var uppercase_allowed;
        var url_title_textinput;
        var url_title;
        var title_textinput;
        var title;
        var find;
        
        url_title_textinput = document.getElementById('url_title');
        title_textinput = document.getElementById('title');
        uppercase_allowed = '{$uppercase_allowed}';
        if (uppercase_allowed == 'y' && url_title_textinput) {
          url_title = url_title_textinput.value;
          title = title_textinput.value;
          //alert('url_title: ' + url_title);
          for (var i = 65; i < 91; i++ ) {
            find = new RegExp('x' + i + 'x', 'g');
            //alert('find: ' + find);
            url_title = url_title.replace(find, String.fromCharCode(i));
            //alert('2 url_title: ' + url_title);
            title = title.replace(find, String.fromCharCode(i));
          }
          url_title_textinput.value = url_title;
          title_textinput.value = title;
        }
      },
      
      liveUrlTitleNew: function() {
        urlTitleSymbols.encodeUppercase();
        liveUrlTitle();
        urlTitleSymbols.decodeUppercase();
        urlTitleSymbols.parseURLTitle();
      },
      
      init: function() {
        var title_textinput;
        
        title_textinput = document.getElementById('title');
        if (title_textinput) {
          title_textinput.onkeyup = urlTitleSymbols.liveUrlTitleNew;
        }
      }
    
    }
    
    urlTitleSymbols.addEvent(window, 'load', urlTitleSymbols.init, false);
    </script>
    <?php
    $buffer = ob_get_contents();	
    ob_end_clean();
    
    $buffer = str_replace('{$dashes_allowed}', $dashes_allowed, $buffer);
    $buffer = str_replace('{$underscores_allowed}', $underscores_allowed, $buffer);
    $buffer = str_replace('{$periods_allowed}', $periods_allowed, $buffer);
    $buffer = str_replace('{$uppercase_allowed}', $uppercase_allowed, $buffer);
    $buffer = str_replace('{$separator}', $separator, $buffer);
    
    if (($IN->GBL('C') == 'publish' AND $IN->GBL('M') == 'entry_form') OR ($IN->GBL('C') == 'edit' AND $IN->GBL('M') == 'edit_entry'))
    {
      $out = str_replace('</body>', $buffer.'</body>', $out);
    }
    
    return $out;
  }
  // END FUNCTION
}
// END CLASS
?>